--- downtime.c-orig	2007-01-08 15:24:13.000000000 -0700
+++ downtime.c	2007-02-15 16:23:42.000000000 -0700
@@ -424,7 +424,10 @@
 		if(temp_downtime->type==HOST_DOWNTIME && hst->scheduled_downtime_depth==0){
 
 			/* log a notice - this one is parsed by the history CGI */
-			snprintf(buffer,sizeof(buffer),"HOST DOWNTIME ALERT: %s;STARTED; Host has entered a period of scheduled downtime",hst->name);
+			if (temp_downtime->is_restart)
+				snprintf(buffer,sizeof(buffer),"INITIAL HOST DOWNTIME STATE: %s;STARTED; Host has entered a period of scheduled downtime",hst->name);
+			else
+				snprintf(buffer,sizeof(buffer),"HOST DOWNTIME ALERT: %s;STARTED; Host has entered a period of scheduled downtime",hst->name);
 			buffer[sizeof(buffer)-1]='\x0';
 			write_to_all_logs(buffer,NSLOG_INFO_MESSAGE);
 		        }
@@ -432,7 +435,10 @@
 		else if(temp_downtime->type==SERVICE_DOWNTIME && svc->scheduled_downtime_depth==0){
 
 			/* log a notice - this one is parsed by the history CGI */
-			snprintf(buffer,sizeof(buffer),"SERVICE DOWNTIME ALERT: %s;%s;STARTED; Service has entered a period of scheduled downtime",svc->host_name,svc->description);
+			if (temp_downtime->is_restart)
+				snprintf(buffer,sizeof(buffer),"INITIAL SERVICE DOWNTIME STATE: %s;%s;STARTED; Service has entered a period of scheduled downtime",svc->host_name,svc->description);
+			else
+				snprintf(buffer,sizeof(buffer),"SERVICE DOWNTIME ALERT: %s;%s;STARTED; Service has entered a period of scheduled downtime",svc->host_name,svc->description);
 			buffer[sizeof(buffer)-1]='\x0';
 			write_to_all_logs(buffer,NSLOG_INFO_MESSAGE);
 		        }
@@ -809,27 +815,27 @@
 /******************************************************************/
 
 /* adds a host downtime entry to the list in memory */
-int add_host_downtime(char *host_name, time_t entry_time, char *author, char *comment_data, time_t start_time, time_t end_time, int fixed, unsigned long triggered_by, unsigned long duration, unsigned long downtime_id){
+int add_host_downtime(char *host_name, time_t entry_time, char *author, char *comment_data, time_t start_time, time_t end_time, int fixed, unsigned long triggered_by, unsigned long duration, unsigned long downtime_id, int is_restart){
 	int result;
 
-	result=add_downtime(HOST_DOWNTIME,host_name,NULL,entry_time,author,comment_data,start_time,end_time,fixed,triggered_by,duration,downtime_id);
+	result=add_downtime(HOST_DOWNTIME,host_name,NULL,entry_time,author,comment_data,start_time,end_time,fixed,triggered_by,duration,downtime_id,is_restart);
 
 	return result;
         }
 
 
 /* adds a service downtime entry to the list in memory */
-int add_service_downtime(char *host_name, char *svc_description, time_t entry_time, char *author, char *comment_data, time_t start_time, time_t end_time, int fixed, unsigned long triggered_by, unsigned long duration, unsigned long downtime_id){
+int add_service_downtime(char *host_name, char *svc_description, time_t entry_time, char *author, char *comment_data, time_t start_time, time_t end_time, int fixed, unsigned long triggered_by, unsigned long duration, unsigned long downtime_id, int is_restart){
 	int result;
 
-	result=add_downtime(SERVICE_DOWNTIME,host_name,svc_description,entry_time,author,comment_data,start_time,end_time,fixed,triggered_by,duration,downtime_id);
+	result=add_downtime(SERVICE_DOWNTIME,host_name,svc_description,entry_time,author,comment_data,start_time,end_time,fixed,triggered_by,duration,downtime_id,is_restart);
 
 	return result;
         }
 
 
 /* adds a host or service downtime entry to the list in memory */
-int add_downtime(int downtime_type, char *host_name, char *svc_description, time_t entry_time, char *author, char *comment_data, time_t start_time, time_t end_time, int fixed, unsigned long triggered_by, unsigned long duration, unsigned long downtime_id){
+int add_downtime(int downtime_type, char *host_name, char *svc_description, time_t entry_time, char *author, char *comment_data, time_t start_time, time_t end_time, int fixed, unsigned long triggered_by, unsigned long duration, unsigned long downtime_id, int is_restart){
 	scheduled_downtime *new_downtime=NULL;
 	scheduled_downtime *last_downtime=NULL;
 	scheduled_downtime *temp_downtime=NULL;
@@ -883,6 +889,7 @@
 	new_downtime->is_in_effect=FALSE;
 	new_downtime->start_flex_downtime=FALSE;
 	new_downtime->incremented_pending_downtime=FALSE;
+	new_downtime->is_restart=is_restart;
 #endif
 
 
